      subroutine hec_dig_calc_weights
c
c calculate a weight for each time slice used in the digital
c filtering method for each channel used
c
      implicit none
c
      include'hec_par.inc'      ! shared parameters
      include'hec_geo.inc'      ! geometry correspondence tables
      include'hec_dig_sys.inc'  ! digital filtering system common 
      include'hec_tdc.inc'      ! tdc values
c
c local variables
c
      integer ic, i_t, iw
c
c initialize the weights to zero
c
      call vzero(dig_weight_amp,i_adc_dim*mx_nslice_dig)    
      call vzero(dig_weight_tim,i_adc_dim*mx_nslice_dig)
c
c calculate the weights for amplitude and time reconstruction
c
      do ic = 1, i_adc_used
        do i_t = 1, nslice_dig
          do iw = 1, iwmax
            dig_weight_amp(ic,i_t) = dig_weight_amp(ic,i_t) + 
     +         dig_amp_par(ic,i_t,iw)*(tdc_ns)**(iw-1)
            dig_weight_tim(ic,i_t) = dig_weight_tim(ic,i_t) + 
     +         dig_tim_par(ic,i_t,iw)*(tdc_ns)**(iw-1)
          enddo
        enddo
      enddo
c
      return
      end


