      subroutine hec_his_evt_hfill
c
c fill histos in event loop that are not done for every channel
c
      implicit none
c
      include 'hec_par.inc'     ! shared parameters
      include 'hec_datacard.inc' ! datacard values
      include 'hec_geo.inc'     ! geometry correspondence tables
      include 'hec_his_sys.inc' ! histo ids, etc.
      include 'hec_max.inc'     ! maximum adc and time values
      include 'hec_tdc.inc'     ! tdc value
c
c local variables
c
      real clus_sum_array(nclust_dim), ratio
      integer id, i_z, nid1
      integer iclus, ic, i, iz
      real clus_sum
c
c histo type 4 -- tdc corrected
c
      if (histo_switch(4) .eq. 1) then
c
c fill tdc distribution histo
c
        nid1 = 0
        id = id_tdc 
ccc        call hff1(id, nid1, tdc_ns, 1.)              
        call hfill(id,tdc_ns, 0., 1.)
      endif
c
c histo type 5 -- calibrated
c
      if (histo_switch(5) .eq. 1) then
c
c fill sigma cut energy histos
c
        id = id_sigma + 1
        call hfill(id, sum_sigma(1), 0., 1.)
        id = id_sigma + 2
        call hfill(id, sum_sigma(2), 0., 1.)
        id = id_sigma + 3
        call hfill(id, sum_sigma(3), 0., 1.)
      endif
c
c histo type 6 -- clusters
c
      if (histo_switch(6) .eq. 1) then
        do iclus = 1, nclust_dim
          clus_sum = 0.
          do i = 1, his_clus_cell_array(1,iclus)
            ic = his_clus_cell_array(i+1,iclus)
            iz = ictoph(ic,3)
            clus_sum = clus_sum + depthw(iz)*adc_max_ic(ic,1)
          enddo
          clus_sum_mom0(iclus) = clus_sum_mom0(iclus) + 1
          clus_sum_mom1(iclus) = clus_sum_mom1(iclus) + clus_sum
          clus_sum_array(iclus) = clus_sum
c
c fill histograms
c
          if (mod(iclus,2) .eq. 0 .and. clus_sum_array(iclus-1) .ne.0) 
     +      then
            ratio = clus_sum_array(iclus)/clus_sum_array(iclus-1)
c            print *,'MAD filling ', id_clus+199+iclus,' with ',ratio
            call hfill(id_clus+199+iclus,ratio,0.,1.)
          endif
          call hfill(id_clus+100+iclus,clus_sum,0.,1.)
        enddo
      endif
c
c histo type 2 -- geometrical energy distribution
c
      if (histo_switch(2) .eq. 1) then
c
c fill adc(max)-ped histograms for each depth
c
        do i_z = 1, i_z_used
          call hfill(id_adc_z + i_z,sig_sum(i_z),0.,1.)
        enddo
      endif
c
      return 
      end
