      subroutine hec_online_hisview
c
c allow viewing of online histogram files in higz window
c
      implicit none
c
      include'hec_par.inc'       ! shared parameters
      include'hec_paw.inc'       ! paw common
      include'hec_geo.inc'       ! geometry correspondence tables
      include'hec_online.inc'    ! online common
      include'hec_runh.inc'      ! run header common
      include'hec_datacard.inc'  ! datacard values
      include'hec_his_sys.inc'   ! online histogram numbers
c
c define flag that determines what is included in .ps file
c define flag that determines whether zoom button has been pushed
c
      logical psbutton, zoombutton, gaussbutton, zonebutton, zoomstatus
c
c local variables
c
      integer hisnum, sig_index(i_adc_dim),ic,high_ic(6)
      integer hisorg
      character*5 chidh
      character*20 comment
c
      real sigpar(3),chi2, par(3)
      integer cur_zone, pic_count
c
c declare hbook functions
c
      real hmax,hstati
      external hmax,hstati
c
      cur_zone = 1
      call hplint(1)
      call hplopt('STAT',1)
c
      hisnum = -1
      zoomstatus = .false.
c
c use cernlib sorting routine to find highest energy cells
c write ic of 5 highest energy cells to a text file if we are in 
c script controlled "autorun" mode.
c
c also, write out histogram number of highest energy cluster
c
c
      call sortzv(average_max,sig_index,i_adc_used,1,1,0)
      if (auto_run .eq. 1) then
        open(35,file="highcell.list",status="NEW")
        write(35, *) run_no
        write(35, '(5i3)') (sig_index(ic), ic = 1, 5)
        write(35,*) clusmax_histo_numb
        close(35)
      endif
c
c copy five highest cells to special array for use in choosing 
c histograms, also use this array to pass number of maximum cluster
c (sorry, this is not so nice....)
c
      do ic = 1, 5
        high_ic(ic) = sig_index(ic)
      enddo
      high_ic(6) = clusmax_histo_numb
c
c start with a zone 1 2 noise plot
c
      call igmeta(0,0)
      call hec_online_hisdispl(9990,high_ic,int(run_no),zoomstatus)
      call iuwk(0,1)
      call igterm
c
c fill the run summary postscript file
c
      open(unit=15,file='run_summary.ps',form='formatted',
     +     status='unknown')
      call igmeta(-15,-111)
      call hec_online_hisdispl(9996,high_ic,run_no,zoomstatus)
ccc      call hec_online_hisdispl(9990,high_ic,run_no,zoomstatus)
      call hec_online_hisdispl(9991,high_ic,run_no,zoomstatus)
      call hec_online_hisdispl(9992,high_ic,run_no,zoomstatus)
ccc      call hec_online_hisdispl(9993,high_ic,run_no,zoomstatus)
      call hec_online_hisdispl(9994,high_ic,run_no,zoomstatus)
      call hec_online_hisdispl(9995,high_ic,run_no,zoomstatus)

      call igmeta(999,0)
      close(15)
c
c list histogram menu
c
      call hec_online_menu
      if (.not. calo_on_flag) then
        print *,' '
        print *,'WARNING!!!: no ADCs read for this run,'
     +         ,'            most histograms not available'
        print *,' '
      endif
c
c open user summary ps file
c
      open(unit=10,file='user_summary.ps',form='formatted',
     +status='unknown')
c
c while the user has not entered 0 as a histogram number
c
      pic_count = 0
      do while (hisnum .ne. 0)
c
c choose zone for plot, pic_count tells hplot where to put the 
c next histogram (eg. in 1st, 2nd, 3rd or 4th position in zone 2 2)
c
        if (cur_zone .eq. 1) then
          call hplzon(1,1,1,' ')
          pic_count = 0
        elseif (cur_zone .eq. 2) then
          if (pic_count .eq. 4) then
            pic_count = 0
          endif
          if (pic_count .eq. 0) then
            call hplzon(2,2,pic_count+1,' ')
            pic_count = pic_count + 1
          else
            call hplzon(2,2,pic_count+1,'S')
            pic_count = pic_count + 1
          endif          
        endif
c
c prompt user for histogram number and read from keyboard
c
        print *, ' ***ENTER 9999 TO LIST HISTOGRAMS'
        print *, ' ***ENTER HISTOGRAM NUMBER TO DISPLAY'
        print *, ' ***ENTER 0 TO GO TO PRINT MENU (EXIT HISTO MENU)'
        read(5,*,ERR=10) hisnum
c
        if (hisnum .ne. 0) then
          if (hisnum .eq. 15000) call hec_online_clus_menu(hisnum)
c
c reset flags
c
          psbutton = .false.
          zoombutton = .false.
          gaussbutton = .false.
          zonebutton = .false.
c
c send output to graphical window only
c
          call igmeta(0,-111)
c
c call routine which knows how to display each histogram (all the fancy 
c labels etc.)
c
          call hec_online_hisdispl(hisnum,high_ic,run_no,zoomstatus)
c
c display histo and read buttons if chosen histo is not a control or run 
c summary number
c
          if (abs(hisnum) .lt. 9000 .or. (abs(hisnum) .gt. 9989
     +        .and. abs(hisnum) .ne. 9999)) then
c
c instruct user
c
            print *,'############################################### '
            print *,'Click left mouse button on PS to add histogram',
     +              ' to user summary'
            print *,'############################################### '
            print *,'Click left mouse button on ZOOM to zoom on ', 
     +              'histogram'
            print *,'############################################### '
            print *,'Click left mouse button on GAUSS to fit Gaussian ', 
     +              'on histogram'
            print *,'############################################### '
            print *,'Click left mouse button on ZONE to change # of  ', 
     +              'plots per page (1->4 or 4->1)'
            print *,'############################################### '
            print *,'Click right mouse button on histogram to return ',
     +               'to histogram menu' 
            print *,'############################################### '
c
            call hec_online_hisbut(psbutton,zoombutton,gaussbutton,
     +                             zonebutton)
          endif
c
c control over display is now given to HIGZ window and mouse
c as long as user always presses a button, the loop continues.
c right mouse button exits
c
c a zoom will change the current histogram number (hisnum), keep the
c original as hisorg
c
          zoomstatus = .false.
          hisorg = hisnum
          do while (psbutton .or. zoombutton .or. gaussbutton
     +              .or. zonebutton)
c
c if user has chosen zoom button, zoom on displayed plot
c
c zoomed plot has histo id > 1100000
c
            if (zoombutton) then
              hisnum = 9900
              call hec_online_hisdispl(hisnum,high_ic,run_no,zoomstatus)
              zoomstatus = .true.
c
c if user has chosen .ps button, put plot directly to ps (no display)
c
            elseif (psbutton) then
              call igmeta(-10,-111)
                call hec_online_hisdispl(hisnum,high_ic,run_no,
     +                                   zoomstatus)                
c
c if user has chosen gauss button, fit gaussian to plot
c
            elseif (gaussbutton) then
              par(1)= hmax(hisnum)
              par(2)= hstati(hisnum,1,' ',0)
              par(3)= hstati(hisnum,2,' ',0)
              call hfithn(hisnum,'g',' ',3,par,par,par,par,sigpar,chi2)
              call hec_online_hisdispl(hisnum,high_ic,run_no,
     +          zoomstatus)                
c
c if user presses zone button, change the zone to either 2,2 or 1,1....
c w
c
            elseif (zonebutton) then
              if (cur_zone .eq. 2) then
                call hplzon(1,1,1,' ')       
                cur_zone = 1
                print *,' '
                print *,'Changing Zone from 4/page to 1/page'
                print *,' '
              elseif (cur_zone .eq. 1) then
                call hplzon(2,2,1,' ')       
                cur_zone = 2
                print *,' '
                print *,'Changing Zone from 1/page to 4/page'
                print *,' '                
              endif
            endif
c
c
c if this routine has just zoomed 
c add a comment to the plot
c
            if (zoomstatus) then
              call izitoc(hisorg,chidh)
              comment = 'Zoom on '//chidh
              call hplsof(12.,18.2,comment,0.5,0.,0.,-1.)
            endif
c
c reset display to go only to screen (not .ps)
c
            call igmeta(0,-111)
c
c instruct user
c
            print *,'############################################### '
            print *,'Click left mouse button on PS to add histogram',
     +              ' to user summary'
            print *,'############################################### '
            print *,'Click left mouse button on ZOOM to zoom on ', 
     +              'histogram'
            print *,'############################################### '
            print *,'Click left mouse button on GAUSS to fit Gaussian ', 
     +              'on histogram'
            print *,'############################################### '
            print *,'Click left mouse button on ZONE to change # of  ', 
     +              'plots per page (1->4 or 4->1)'
            print *,'############################################### '
            print *,'Click right mouse button on histogram to return ',
     +               'to histogram menu' 
            print *,'############################################### '
c
c put the buttons on
c
            call hec_online_hisbut(psbutton,zoombutton,gaussbutton,
     +                             zonebutton)
c
          enddo
c
        endif
c
        call igterm
c
c if no error (ie got to here) skip error handling block
c
        goto 11
 10     continue
        print *, ' ***Not a valid histogram number'
        hisnum = -1
 11     continue
c
      enddo
c
c terminate hplot
c
      call hplend
      close(unit=10)
c
      return
      end




